/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxOutputResponse struct for TxOutputResponse
type TxOutputResponse struct {
	// The output index within a given transaction.
	Index *int32 `json:"index,omitempty"`
	// The transaction identifier.
	TxId *string `json:"tx_id,omitempty"`
	// The transaction creation unix timestamp.
	Date *int64 `json:"date,omitempty"`
	// The hash identifier of the block which the transaction was mined.
	BlockId *string `json:"block_id,omitempty"`
	// The number of the block which the transaction was mined.
	BlockNumber *int32 `json:"block_number,omitempty"`
	// The number of confirmations the transaction took in order to be mined.
	Confirmations *int32                `json:"confirmations,omitempty"`
	Meta          *TxOutputResponseMeta `json:"meta,omitempty"`
}

// NewTxOutputResponse instantiates a new TxOutputResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxOutputResponse() *TxOutputResponse {
	this := TxOutputResponse{}
	return &this
}

// NewTxOutputResponseWithDefaults instantiates a new TxOutputResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxOutputResponseWithDefaults() *TxOutputResponse {
	this := TxOutputResponse{}
	return &this
}

// GetIndex returns the Index field value if set, zero value otherwise.
func (o *TxOutputResponse) GetIndex() int32 {
	if o == nil || o.Index == nil {
		var ret int32
		return ret
	}
	return *o.Index
}

// GetIndexOk returns a tuple with the Index field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponse) GetIndexOk() (*int32, bool) {
	if o == nil || o.Index == nil {
		return nil, false
	}
	return o.Index, true
}

// HasIndex returns a boolean if a field has been set.
func (o *TxOutputResponse) HasIndex() bool {
	if o != nil && o.Index != nil {
		return true
	}

	return false
}

// SetIndex gets a reference to the given int32 and assigns it to the Index field.
func (o *TxOutputResponse) SetIndex(v int32) {
	o.Index = &v
}

// GetTxId returns the TxId field value if set, zero value otherwise.
func (o *TxOutputResponse) GetTxId() string {
	if o == nil || o.TxId == nil {
		var ret string
		return ret
	}
	return *o.TxId
}

// GetTxIdOk returns a tuple with the TxId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponse) GetTxIdOk() (*string, bool) {
	if o == nil || o.TxId == nil {
		return nil, false
	}
	return o.TxId, true
}

// HasTxId returns a boolean if a field has been set.
func (o *TxOutputResponse) HasTxId() bool {
	if o != nil && o.TxId != nil {
		return true
	}

	return false
}

// SetTxId gets a reference to the given string and assigns it to the TxId field.
func (o *TxOutputResponse) SetTxId(v string) {
	o.TxId = &v
}

// GetDate returns the Date field value if set, zero value otherwise.
func (o *TxOutputResponse) GetDate() int64 {
	if o == nil || o.Date == nil {
		var ret int64
		return ret
	}
	return *o.Date
}

// GetDateOk returns a tuple with the Date field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponse) GetDateOk() (*int64, bool) {
	if o == nil || o.Date == nil {
		return nil, false
	}
	return o.Date, true
}

// HasDate returns a boolean if a field has been set.
func (o *TxOutputResponse) HasDate() bool {
	if o != nil && o.Date != nil {
		return true
	}

	return false
}

// SetDate gets a reference to the given int64 and assigns it to the Date field.
func (o *TxOutputResponse) SetDate(v int64) {
	o.Date = &v
}

// GetBlockId returns the BlockId field value if set, zero value otherwise.
func (o *TxOutputResponse) GetBlockId() string {
	if o == nil || o.BlockId == nil {
		var ret string
		return ret
	}
	return *o.BlockId
}

// GetBlockIdOk returns a tuple with the BlockId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponse) GetBlockIdOk() (*string, bool) {
	if o == nil || o.BlockId == nil {
		return nil, false
	}
	return o.BlockId, true
}

// HasBlockId returns a boolean if a field has been set.
func (o *TxOutputResponse) HasBlockId() bool {
	if o != nil && o.BlockId != nil {
		return true
	}

	return false
}

// SetBlockId gets a reference to the given string and assigns it to the BlockId field.
func (o *TxOutputResponse) SetBlockId(v string) {
	o.BlockId = &v
}

// GetBlockNumber returns the BlockNumber field value if set, zero value otherwise.
func (o *TxOutputResponse) GetBlockNumber() int32 {
	if o == nil || o.BlockNumber == nil {
		var ret int32
		return ret
	}
	return *o.BlockNumber
}

// GetBlockNumberOk returns a tuple with the BlockNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponse) GetBlockNumberOk() (*int32, bool) {
	if o == nil || o.BlockNumber == nil {
		return nil, false
	}
	return o.BlockNumber, true
}

// HasBlockNumber returns a boolean if a field has been set.
func (o *TxOutputResponse) HasBlockNumber() bool {
	if o != nil && o.BlockNumber != nil {
		return true
	}

	return false
}

// SetBlockNumber gets a reference to the given int32 and assigns it to the BlockNumber field.
func (o *TxOutputResponse) SetBlockNumber(v int32) {
	o.BlockNumber = &v
}

// GetConfirmations returns the Confirmations field value if set, zero value otherwise.
func (o *TxOutputResponse) GetConfirmations() int32 {
	if o == nil || o.Confirmations == nil {
		var ret int32
		return ret
	}
	return *o.Confirmations
}

// GetConfirmationsOk returns a tuple with the Confirmations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponse) GetConfirmationsOk() (*int32, bool) {
	if o == nil || o.Confirmations == nil {
		return nil, false
	}
	return o.Confirmations, true
}

// HasConfirmations returns a boolean if a field has been set.
func (o *TxOutputResponse) HasConfirmations() bool {
	if o != nil && o.Confirmations != nil {
		return true
	}

	return false
}

// SetConfirmations gets a reference to the given int32 and assigns it to the Confirmations field.
func (o *TxOutputResponse) SetConfirmations(v int32) {
	o.Confirmations = &v
}

// GetMeta returns the Meta field value if set, zero value otherwise.
func (o *TxOutputResponse) GetMeta() TxOutputResponseMeta {
	if o == nil || o.Meta == nil {
		var ret TxOutputResponseMeta
		return ret
	}
	return *o.Meta
}

// GetMetaOk returns a tuple with the Meta field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponse) GetMetaOk() (*TxOutputResponseMeta, bool) {
	if o == nil || o.Meta == nil {
		return nil, false
	}
	return o.Meta, true
}

// HasMeta returns a boolean if a field has been set.
func (o *TxOutputResponse) HasMeta() bool {
	if o != nil && o.Meta != nil {
		return true
	}

	return false
}

// SetMeta gets a reference to the given TxOutputResponseMeta and assigns it to the Meta field.
func (o *TxOutputResponse) SetMeta(v TxOutputResponseMeta) {
	o.Meta = &v
}

func (o TxOutputResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Index != nil {
		toSerialize["index"] = o.Index
	}
	if o.TxId != nil {
		toSerialize["tx_id"] = o.TxId
	}
	if o.Date != nil {
		toSerialize["date"] = o.Date
	}
	if o.BlockId != nil {
		toSerialize["block_id"] = o.BlockId
	}
	if o.BlockNumber != nil {
		toSerialize["block_number"] = o.BlockNumber
	}
	if o.Confirmations != nil {
		toSerialize["confirmations"] = o.Confirmations
	}
	if o.Meta != nil {
		toSerialize["meta"] = o.Meta
	}
	return json.Marshal(toSerialize)
}

type NullableTxOutputResponse struct {
	value *TxOutputResponse
	isSet bool
}

func (v NullableTxOutputResponse) Get() *TxOutputResponse {
	return v.value
}

func (v *NullableTxOutputResponse) Set(val *TxOutputResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableTxOutputResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableTxOutputResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxOutputResponse(val *TxOutputResponse) *NullableTxOutputResponse {
	return &NullableTxOutputResponse{value: val, isSet: true}
}

func (v NullableTxOutputResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxOutputResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
